//    
//  Minimum, maximum, predecessor, successor raudonai-juodo medzhio pagrindu
//  

//---------------------------=[ PREPROCESORIUS ]=-------------------------------

#include <iostream>
using namespace std;

//---------------------------=[ APSIBREZHIAM MAZGA ]=---------------------------

struct mazgas{
	mazgas *kaire;    
	mazgas *desine; 
	mazgas *tevas;
	int spalva;
	int skaicius;
};

#define NIL &sentinel          
mazgas sentinel = {NIL, NIL, 0, 0, 0};

mazgas *saknis = NIL;

//---------------------------=[ MENIU ]=----------------------------------------

void MENIU() {
     cout << "===================================" << endl;
     cout << "| Meniu                       | 1 |" << endl;
     cout << "|-----------------------------|---|" << endl;
     cout << "| Sugeneruoti skaicius        | 2 |" << endl;
     cout << "| Rasti minimum               | 3 |" << endl;
     cout << "| Rasti maximum               | 4 |" << endl;
     cout << "| Rasti successor             | 5 |" << endl;
     cout << "| Rasti predecessor           | 6 |" << endl;
     cout << "| Isvesti medzio elementus    | 7 |" << endl;
     cout << "| Baigti programos darba      | 8 |" << endl;
     cout << "===================================" << endl;
}
//---------------------------=[ POSUKIS KAIREN ]=-------------------------------

void PASUK_KAIREN(mazgas *x) {
	mazgas *y = x->desine;
	x->desine = y->kaire;
	if (y->kaire != NIL) 
		y->kaire->tevas = x;	
	if (y != NIL) 				
		  y->tevas = x->tevas;
    if (x->tevas){
  		if (x == x->tevas->kaire)
        	x->tevas->kaire = y;
       	else
           x->tevas->desine = y;
    } 
    else{
  		saknis = y;
    }
    y->kaire = x;
    if (x != NIL) 
        x->tevas = y;
}
//---------------------------=[ POSUKIS DESHINEN ]=-----------------------------

void PASUK_DESINEN(mazgas *x){
	mazgas *y = x->kaire;
	x->kaire = y->desine;
	if (y->desine != NIL) 
        y->desine->tevas = x;
    if (y != NIL) 
  	    y->tevas = x->tevas;
    if (x->tevas){
  		if (x == x->tevas->desine)
        	x->tevas->desine = y;
        else
            x->tevas->kaire = y;
    } 
    else{
  	    saknis = y;
    }
    y->desine = x;
    if (x != NIL) 
    	x->tevas = y;
}
//---------------------------=[ SPALVINIMAS ]=----------------------------------

void SPALVINK(mazgas *x){
	while (x != saknis && x->tevas->spalva == 1){
		if (x->tevas == x->tevas->tevas->kaire){
			mazgas *y = x->tevas->tevas->desine;
            if(y->spalva == 1){
      	    	x->tevas->spalva = 0;
      	        y->spalva = 0;
      	        x->tevas->tevas->spalva = 1;
      	        x = x->tevas->tevas;
            } 
            else{
      	    	if (x == x->tevas->desine){
      		    	x = x->tevas;
      		    	PASUK_KAIREN(x);
                }
	            x->tevas->spalva = 0;
                x->tevas->tevas->spalva = 1;
                PASUK_DESINEN(x->tevas->tevas);
            }
        } 
        else{
			mazgas *y = x->tevas->tevas->kaire;
	        if (y->spalva == 1){
            	x->tevas->spalva = 0;
                y->spalva = 0;
                x->tevas->tevas->spalva = 1;
            	x = x->tevas->tevas;
            } 
            else{
                if (x == x->tevas->kaire){
                	x = x->tevas;
                	PASUK_DESINEN(x);
                }
                x->tevas->spalva = 0;
                x->tevas->tevas->spalva = 1;
                PASUK_KAIREN(x->tevas->tevas);
            }
        }
    }
    saknis->spalva = 0;
}
//---------------------------=[ ITERPIMAS ]=------------------------------------

mazgas *IDEK_MAZGA(int skaicius){
	mazgas *esamas, *tevas, *x;
	esamas = saknis;
	tevas = 0;
    while(esamas != NIL){
    //	if(skaicius== esamas->skaicius) 
    //    	return(esamas);
        tevas = esamas;
        esamas = (skaicius < esamas->skaicius) ?
        esamas->kaire : esamas->desine;
    }
    x = new mazgas;
    x->skaicius = skaicius;
    x->tevas = tevas;
    x->kaire = NIL;
    x->desine = NIL;
    x->spalva = 1;
    if(tevas){
    	if(skaicius < tevas->skaicius)
        	tevas->kaire = x;
        else
        	tevas->desine = x;
	} 
    else{
    	saknis = x;
    }
    SPALVINK(x);
    return(x);
}

//---------------------------=[ GENERAVIMAS ]=----------------------------------

void GENERUOK(int kiekis){
	for(int i=0; i<kiekis ;i++){
		int atsitiktinis = rand()%1000;
		IDEK_MAZGA(atsitiktinis);
	}
}

//---------------------------=[ MINIMUMAS ]=------------------------------------

void MINIMUM(mazgas *visas){

    while (visas->kaire != NIL)
    	visas = visas->kaire;
    cout << visas->skaicius;   
}

//---------------------------=[ MAKSIMUMAS ]=-----------------------------------

void MAXIMUM(mazgas *visas){

    while (visas->desine != NIL)
    	visas = visas->desine;
    cout << visas->skaicius;
}

//---------------------------=[ GAUNAM MAX ]=-----------------------------------

int GETMAX(mazgas *visas){
    int max;
    while (visas->desine != NIL)
    	visas = visas->desine;
    max = visas->skaicius;
  return(max);
}

//---------------------------=[ GAUNAM MIN ]=-----------------------------------

int GETMIN(mazgas *visas){
    int min;
    while (visas->kaire != NIL)
    	visas = visas->kaire;
    min = visas->skaicius;
  return(min);
}

//---------------------------=[ SUCCESSOR ]=------------------------------------

void SUCCESSOR(mazgas *visas,int ieskomasSkaicius){
  
  if(ieskomasSkaicius != GETMAX(visas)){
   
    while(visas!=NIL && visas->skaicius!=ieskomasSkaicius){
		if(visas->skaicius > ieskomasSkaicius)
			visas = visas->kaire;
		else
			visas = visas->desine;
	}
	if(visas->skaicius==ieskomasSkaicius){	
		if (visas->desine != NIL)
			return MINIMUM(visas->desine);
    
		mazgas *y = visas->tevas;
		while((y!=NIL)&&(visas == y->desine)){
			visas=y;
			y=y->tevas;	
		}

        cout << y->skaicius << endl; 
        
  
          
	} 
else
		cout << "Ivesto elemento nera" << endl;
    }

	else 
         cout << "Ivedete maximalu elementa, successor nera.." << endl;
}
    
//---------------------------=[ PRECESSOR ]=------------------------------------    

void PREDECESSOR(mazgas *visas,int ieskomasSkaicius){

    
    if(ieskomasSkaicius != GETMIN(visas)){
    
    
    
    while(visas!=NIL && visas->skaicius!=ieskomasSkaicius){
		if(visas->skaicius > ieskomasSkaicius)
			visas = visas->kaire;
		else
			visas = visas->desine;
	}
	if(visas->skaicius==ieskomasSkaicius){	
		if (visas->kaire != NIL)
		
            return MAXIMUM(visas->kaire);
		
		
		mazgas *y = visas->tevas;
		while((y!=NIL)&&(visas == y->kaire)){
			visas=y;
			y=y->tevas;
 
		}
		cout << y->skaicius << endl; 
    

	} 
	else
		cout << "Ivesto elemento nera" << endl;
}
   else
       cout << "Ivedete maziausia elementa, skaicius predecessor neturi.." << endl;		
		
}

//---------------------------=[ ISVEDIMAS ]=------------------------------------

void ISVESK(mazgas *visas){
	if(visas->kaire!=NIL)
		ISVESK(visas->kaire);
	cout << visas->skaicius<<endl;
	if(visas->desine!=NIL)
		ISVESK(visas->desine);
}

//---------------------------=[ MAINAS ]=---------------------------------------

int main() {
    int ieskomasSkaicius;
    int kiekis;

    mazgas *visas;
    char number = '1';
    do {
      //   system("cls");
         switch(number) {
           case '1': MENIU();
                     break;
           case '2': cout << "Kiek elementu norite sugeneruoti" << endl;
                     cin >> kiekis;
                     GENERUOK(kiekis);
                     break;
           case '3': cout << "Maziausias elementas yra: ";
           			 visas = saknis;
                     MINIMUM(visas);
                
                     break;
           case '4': cout << "Didziausias elementas yra: ";
           			 visas = saknis;
                     MAXIMUM(visas);
                     
                     break;
           case '5': cout << "Iveskite skaiciu: ";
                     cin >> ieskomasSkaicius;
                  
                     SUCCESSOR(visas,ieskomasSkaicius);
                     
                  
                     break;
           case '6': cout << "Iveskite skaiciu: ";
                     cin >> ieskomasSkaicius;
                     PREDECESSOR(visas,ieskomasSkaicius);
                     break;
           case '7': cout << "Ivesti buvo sie elementai:" << endl;
           			 visas = saknis;
				 	 ISVESK(visas);					 	
					 break;
           default:  cout << "Ivedete neteisinga numeri, tokios operacijos nera " << endl 
                         << "Paspaude 1, grisite i Meniu.\n";
                     break;
         }
         cout << endl << endl << "Iveskite norimo veiksmo numeri: ";
         cin >> number;
    } while (number != '8');
    
  system("cls");
  cout << "Darbas baigtas.\n" << endl;
    
    getchar();
    getchar();
    return 0;
}
